%{
#include <stdlib.h>
#include <stdio.h>
#include <string.h>


int yylex( void );
int yyline=0;
int i;

int pozx,pozy,sx=1,sy=0;


void pomeri(int);
void rot_left();
void rot_right();

%}

%union{
   char tekst[100];
}

%token K_START K_GO K_TURN S_RIGHT S_LEFT K_REPEAT K_END
%token <tekst> NUM
%start ulaz


%%

ulaz : K_START NUM NUM 
	{
	pozx=atoi($2); pozy=atoi($3);
	}
      komande

komande : komanda
	| komanda komande;

komanda : K_GO NUM
	{
	pomeri(atoi($2));
	if (pozx<0 || pozx>100 || pozy<0 || pozy>100) {
		printf("Nedozvoljena pozicija robota\n"); 
		return;
		}
	}
	| K_TURN S_LEFT
	{
	rot_left();
	}
	| K_TURN S_RIGHT
	{
	rot_right();
	}
	| K_REPEAT NUM K_GO NUM K_END
	{
	int i;
	for (i=0;i<atoi($2);i++) pomeri(atoi($4));
	if (pozx<0 || pozx>100 || pozy<0 || pozy>100) {
		printf("Nedozvoljena pozicija robota\n"); 
		return;
		}
	}
	| K_REPEAT NUM K_TURN S_LEFT K_END
	{
	int i;
	for (i=0;i<atoi($2);i++) rot_left();
	}
	| K_REPEAT NUM K_TURN S_RIGHT K_END
	{
	int i;
	for (i=0;i<atoi($2);i++) rot_right();
	}


%%

void pomeri(int d)
{
	pozx+=sx*d;
	pozy+=sy*d;
	
}

void rot_left()
{
	if(sx) {sy=sx; sx=0;}
	else {sx=-sy; sy=0;}
}

void rot_right()
{
	if(sx) {sy=-sx; sx=0;}
	else {sx=sy; sy=0;}
}

int yyerror(char *s)
{ 
   printf("ERR: %s RED: %d\n",s,yyline);
}


int main(int argc, char *argv[]){
	extern FILE *yyin;
        int i,j;
	yyin=fopen(argv[1],"r");
	yyparse();
	printf("%d %d\n",pozx,pozy);
	fclose(yyin);
	return 0;
}
